/* FileManagerType.h */

#ifndef _FILEMANAGERTYPE_H_
#define _FILEMANAGERTYPE_H_

/* Application launching code */
#define AppLaunchFromSLFM	sysAppLaunchCmdCustomBase

/* Structure of parameter */
typedef struct {
	UInt32		cpCreatorID;
	UInt16		cpCardNo;
	UInt8		cpReserved[3];
	Char		*cpFile;
} typeCmdParam;

/* Definition of parameter */
typeCmdParam	*cmdParam;

/* Function of freeing file path parameter's memory */
#define CMDPARAMPATHFREE()		\
	if (cmdParam != NULL) {					\
		if (cmdParam->cpFile != NULL) {		\
			MemPtrFree(cmdParam->cpFile);	\
			cmdParam->cpFile = NULL;		\
		}									\
	}

/* Function of freeing parameter's memory */
#define CMDPARAMFREE()		\
	if (cmdParam != NULL) {				\
		CMDPARAMPATHFREE();				\
		MemPtrFree(cmdParam);			\
		cmdParam = NULL;				\
	}

/* Function of initializing parameter */
#define CMDPARAMINIT(creator, cardno, path, err)		\
	if (cmdParam = (typeCmdParam *)MemPtrNew(sizeof(typeCmdParam))) {		\
		if (!(err = MemPtrSetOwner(cmdParam, 0))) {							\
			cmdParam->cpCreatorID = creator;								\
			cmdParam->cpCardNo = cardno;									\
			if (cmdParam->cpFile = (Char *)MemPtrNew(StrLen(path) + 1)) {	\
				if (!(err = MemPtrSetOwner(cmdParam->cpFile, 0))) {			\
					StrCopy(cmdParam->cpFile, path);						\
				}															\
			} else {														\
				err = -1;													\
			}																\
		}																	\
	} else {																\
		err = -1;															\
	}

#endif
